<?php

require_once 'Country.php';
require_once 'Language.php';
require_once 'PaysForm.php';

class CountryController extends Zend_Controller_Action
{ 
 public function init()
  {
   
  }
public function indexAction(){
	$c=new Country();
	$result=$c->fetchAll();
	$this->view->countries=$result;
	$this->render();
} 

public function testAction(){
	//$id=($this->_hasParam('id'))?$this->_getParam('id'):1;
	$id=$this->_getParam('id',1);
	$ct=new Country();
	$pays=$ct->find($id)->current();
	if ($id==73) {
	   $pays->HeadOfState = "Nicolas Sarkozy";
       $pays->save();
	}
	$pays=$ct->find($id)->current(); 
	$this->view->pays=$pays;
	$this->render('voirPays');
}

public function testAddAction(){
 require_once 'City.php';
// Fontion de niveau 'table' et 'tuple'
  $ct = new City(); 
  // les données sont représentées par un dictionnaire
  $data = array(  
    'Name' => 'Test',
    'LocalName' => 'local test',
    'idCountry' => 2,
    'District' => 'titi',
    'Population' => 12    
  ); 
  $cityRow=$ct->createRow($data);  
//  Zend_Debug::dump($cityRow);
  if ($cityRow) {
    $id=$cityRow->save();
    // passage en argument de l'id du pays concerné par ce test
    $this->_setParam('id','2');
    // sous-traitance de service (function villesAction de ce
    // contrôleur, présentée un peu plus loin dans ce doc)
    $this->_forward('villes');            
  }    
}

public function testDeleteAction(){
 require_once 'City.php';
// Fontion de niveau 'table' et 'tuple'
 $ct = new City();
 $where = $ct->getAdapter()->quoteInto('Name = ?', 'Test');
 $ct->delete($where);
 $this->_setParam('id','2');
 $this->_forward('villes');    
     
}


 public function voirPaysAction(){
	//$id=($this->_hasParam('id'))?$this->_getParam('id'):1;
	$id=$this->_getParam('id',1);
	$c=new Country();
	$result=$c->find($id)->current();
	$this->view->pays=$result;
	$this->render();
 }

  public function villesAction()     {
      $idPays=$this->_getParam('id', 1);

      $ct = new Country();
      $paysRow = $ct->find($idPays)->current();
      $villes=$paysRow->getVilles();
      $this->view->villes=$villes;
      $this->view->nomPays=$paysRow->Name;
      $this->render();
   } 

   
   public function languesAction()     {
      $idPays=$this->_getParam('id', 1);
      $ct = new Country();
      $paysRow = $ct->find($idPays)->current();
      $langues=$paysRow->getLanguesParlees();
      $this->view->langues=$langues;
      $this->view->nomPays=$paysRow->Name;
      $this->render();
   } 

   public function paysLangueAction()     {
      $idLangue=$this->_getParam('idlangue', 1);      
      //Zend_Debug::dump($this->getRequest()->getParams());
      $lt = new Language();
      $languageRow = $lt->find($idLangue)->current();         
      $lesPays=$languageRow->getPaysParlantCetteLangue();
      $this->view->lesPays=$lesPays;
      $this->view->nomLangue=$languageRow->Name;
      $this->render();
   } 
   
  public function editAction() {       
        $form = new PaysForm();
        if ($this->_request->isGet()) {
        	$id = $this->_getParam('id', -1);
        	if ($id == -1)
        	   // rien à faire ici
        	   return $this->_helper->redirector('index', 'country');
            $ct=new Country();
            $rowPays=$ct->find($id)->current();
            if ($rowPays) {
            	// initialisation du formulaire
            	// Zend_Debug::dump($rowPays);
            	$form->getElement('HeadOfState')->setValue($rowPays->HeadOfState);
            	$form->getElement('id')->setValue($rowPays->id);
            }                            
        } 
        // reception de donnees ?       
        else if ($this->_request->isPost()) {
            $formData = $this->_request->getPost();
            // nous les affectons au formulaire 
            $form->populate($formData);            
            // qui applique les filtres
            $formData=$form->getValues();            
            // activation des validateurs
            $ct=new Country();            
            $rowPays=$ct->find($formData['id'])->current();
            if ($rowPays && $form->isValid($formData)) {
                // ok, nous pouvons opérer                                         
                $rowPays->HeadOfState = $formData['HeadOfState'];
                // sauvegarde dans la BD
                $id=$rowPays->save();
                // make a "redirect after post"
                // @see http://en.wikipedia.org/wiki/Post/Redirect/Get
                return $this->_helper->redirector('index', 'country');                   
            }
        }                
        // présentation du formulaire
        if ($rowPays) {
          $this->view->action = "Modifier le nom du chef d'état";
          $this->view->pays = $rowPays->Name;        
          $this->view->form = $form;
          $this->render();
        }
        else {
           //sinon, rien à faire ici !
          return $this->_helper->redirector('index', 'country');
        }
  }
  
  public function preDispatch()
  {  	
   if (!Zend_Auth::getInstance()->hasIdentity())
      // voir Zend/Contoller/Action/Helper/Redirector.php
      // $this->_helper->redirector($action, $controller, $module, $params) 
      $this->_helper->redirector('index', 'index');
  }
  
  public function postDispatch()
  {

  }
   
}