<?php
class CountryRow extends Zend_Db_Table_Row_Abstract {

	public function getCapitale() {
		$city = $this->findParentRow('City', 'Capitale');
		// les arguments de findParentRow :
		//  'City' -> c'est la table
		//  'Capitale' -> c'est le rôle défini dans $_referenceMap de County.php 
		return $city;
	}

	public function getCapitaleBis() {
		$db = $this->getTable()->getAdapter();
		// ou : -- voir index.php
		//   $registry = Zend_Registry::getInstance();
		//   $db = $registry.get('db');

		$res = $db->query("SELECT * FROM City WHERE id = ?", array($this->Capital));
		require_once('CityRow.php');
		$city = new CityRow();
		$res->setFetchMode(PDO::FETCH_INTO, $city );
		$city = $res->fetchObject();
		return $city;
	}

	public function getVilles() {
		//return  $this->findDependentRowset('City', 'MonPays');
		return  $this->findCity();
	}

	public function getVillesBis() {
		// "SELECT * FROM City WHERE id = ?", array($this->id)
	}
	 
	public function getLanguesParlees() {
		//return $this->findManyToManyRowset('Language', 'CountryLanguage');
		return $this->findLanguageViaCountryLanguage();		
	}

	public function getNbCities(){
		// TODO
		return -1;
	}



}
